//+------------------------------------------------------------------+
//|                                                       #dtosc.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"


#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 DeepSkyBlue
#property indicator_color2 OrangeRed
#property indicator_width1 2
#property indicator_width2 2

//
//
//
//
//

extern string TimeFrame    = "Current time frame";
extern int    PeriodRSI    = 13;
extern int    PeriodStoch  = 8;
extern int    PeriodSK     = 5;
extern int    PeriodSD     = 3;
extern int    MAMode       = 0;
extern double ArrowUpGap   = 0.75;
extern double ArrowDnGap   = 0.75;
   
//
//
//
//
//

double SK[];
double SD[];
double StoRSI[];
double RSI[];
double trend[];
double arrowUp[];
double arrowDn[];
string IndicatorFileName;
int    timeFrame;
bool   returnBars;
bool   calculateValue;

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,arrowUp); SetIndexStyle(0, DRAW_ARROW); SetIndexArrow(0,241);
      SetIndexBuffer(1,arrowDn); SetIndexStyle(1, DRAW_ARROW); SetIndexArrow(1,242);
      SetIndexBuffer(2,SK);
      SetIndexBuffer(3,SD);
      SetIndexBuffer(4,StoRSI);
      SetIndexBuffer(5,RSI);
      SetIndexBuffer(6,trend);

   //
   //
   //
   //
   //
   
      IndicatorFileName = WindowExpertName();
      returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
      calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
      timeFrame         = stringToTimeFrame(TimeFrame);   

   //
   //
   //
   //
   //
   
   IndicatorShortName(timeFrameToString(timeFrame)+" DTOSC ("+PeriodRSI+","+PeriodStoch+","+PeriodSK+","+PeriodSD+")");
return(0);
}
int deinit()
{
   return(0);
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars = IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars > 0) counted_bars--;
          int limit=MathMin(Bars-counted_bars,Bars-1);
          if (returnBars) { arrowUp[0] = limit; return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i=limit; i>=0; i--)
      {
         RSI[i] = iRSI(NULL,0,PeriodRSI,PRICE_CLOSE,i);
         double LLV = RSI[ArrayMinimum(RSI,PeriodStoch,i)];
         double HHV = RSI[ArrayMaximum(RSI,PeriodStoch,i)];
         if ((HHV-LLV)!=0)
               StoRSI[i] = 100.0*((RSI[i] - LLV)/(HHV - LLV));
         else  StoRSI[i] = 0;
      }   
      for(i=limit; i>=0; i--) SK[i]=iMAOnArray(StoRSI,0,PeriodSK,0,MAMode,i);
      for(i=limit; i>=0; i--)
      {
         SD[i]=iMAOnArray(SK,0,PeriodSD,0,MAMode,i);
         trend[i]   = trend[i+1];
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
            if (SK[i]>SD[i]) trend[i] =  1;
            if (SK[i]<SD[i]) trend[i] = -1;
            if (trend[i]!=trend[i+1])
            {
               if (trend[i] == 1) arrowUp[i] = Low[i] -ArrowUpGap*iATR(NULL,0,20,i);
               if (trend[i] ==-1) arrowDn[i] = High[i]+ArrowDnGap*iATR(NULL,0,20,i);
            }
      }         
      return(0);      
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,IndicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         trend[i] = iCustom(NULL,timeFrame,IndicatorFileName,"calculateValue",PeriodRSI,PeriodStoch,PeriodSK,PeriodSD,MAMode,6,y);
         arrowUp[i] = EMPTY_VALUE;
         arrowDn[i] = EMPTY_VALUE;
            if (trend[i]!=trend[i+1])
            {
               if (trend[i] == 1) arrowUp[i] = Low[i] -ArrowUpGap*iATR(NULL,0,20,i);
               if (trend[i] ==-1) arrowDn[i] = High[i]+ArrowDnGap*iATR(NULL,0,20,i);
            }
   }               
   return(0);
}



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}